try :
	import pwd
	import grp
except :
	pwd = None
	grp = None
# this uglyness was to get the library through when being imported as a client on non-Unix systems

import sys

def stderr(txt) :
	sys.stderr.write(txt + "\n")
	sys.stderr.flush()

users = {}
groups = {}

def gid2user(i) :
	global groups	
	
	if groups.has_key(i) :
		return groups[i]

	g = Group()
	g.getgrgid(i)
	if g.gid > -1 :
		groups[g.gid] = g
		return g

def uid2user(i) :
	global users

	if users.has_key(i) :
		return users[i]

	u = User()
	u.getpwuid(i)
	if u.uid > -1 :
		users[u.uid] = u
		return u
	
class Group :
	def __init__(self) :
		self.gid = -1
		self.name = ''
		self.members = None
	
	def getgrgid(self, gid) :
		try :
			g = grp.getgrgid(gid)
		except :
			return None
		
		self.name = g[0]
		self.gid = g[2]
		self.members = g[3]
		
class User :
	def __init__(self) :
		self.name = ''
		self.uid = -1
		self.gid = -1
	
	def getpwnam(self, name) :
		self.name = ''
		self.uid = -1
		self.gid = -1
	
		try :
			pw = pwd.getpwnam(name)
		except :
			return None

		self.name = pw[0]
		self.uid = pw[2]
		self.gid = pw[3]

		return 1
	
	def getpwuid(self, uid) :
		self.name = ''
		self.uid = -1
		self.gid = -1

		try :
			pw = pwd.getpwuid(uid)
		except :
			return None
		
		self.name = pw[0]
		self.uid = pw[2]
		self.gid = pw[3]

		self._print()

		return 1

	def _print(self) :
		stderr("N: %s  U: %d  G: %d" % (self.name, self.uid, self.gid))
