import socket
import TR_message
import StringIO
import ByteIO

class sockfile :
# the curious setup here is because jython wouldn't use socket.socket as a base class
# class sockfile(socket.socket) :
# reported TypeError: base is not a class object: instance of 'org.python.core.PyFunction'
 
	def __init__(self, sokket) :
		self.recv = sokket.recv
		self.send = sokket.send
		self.connect = sokket.connect
				
	def read(self, n):
		return self.recv(n)
		
	def write(self, data) :
		try :
			self.send(data)
			return len(data)
		except :
			return 0

class one_fid_client :
	msg_size = 8216
	
	def __init__(self, host, username, port=564) :
		self.fid = 1
		self.tag = None
		self.host = host
		self.username = username
		self.port = int(port)
		
		
	def __getattr__(self, attr) :
		if attr == 'next_tag' :
			if self.tag == None :
				self.tag = 0
			else :
				self.tag += 1
			return self.tag
			
		if attr == 'connected' :
			return self.io != None
			
		raise AttributeError, attr
		
	def connect(self) :
		self.io = sockfile(socket.socket(socket.AF_INET, socket.SOCK_STREAM))
		self.io.connect((self.host, self.port))
		
		t = TR_message.Tversion(self.next_tag)
		t.msize = self.msg_size
		t.version = '9P2000'
		t.write_to(self.io)
		r = TR_message.get_message(self.io)

		if r.version != t.version :
			raise '9P Version mismatch', 'I can only do 9p2000'
			
		return r
		
	def attach(self, afid=0, aname='') :
		if not self.connected : return None
			
		t = TR_message.Tattach(self.next_tag)
		t.fid = self.fid
		t.afid = afid
		
		t.uname = self.username
		t.aname = aname
		t.write_to(self.io)
		r = TR_message.get_message(self.io)
		
		return r
		
	def walk(self, path='') :

		t = TR_message.Twalk(self.next_tag)
		t.fid = self.fid
		t.newfid = self.fid
		
		while path[0] == '/' :
			path = path[1:]
		while path[-1:] == '/' :
			path = path[:-1]
			
		t.wname = path.split('/')
		t.write_to(self.io)
		r = TR_message.get_message(self.io)

		return r
	
	def open(self, path='/') :
		if self.walk(path) :
			t = TR_message.Topen(self.next_tag)
			t.fid = self.fid
			t.mode = TR_message.OREAD
			t.write_to(self.io)
			r = TR_message.get_message(self.io)
			try :
				print r.ename
			except :
				pass
			return r
			
	def close(self) :
		t = TR_message.Tclunk(self.next_tag)
		t.fid = self.fid
		t.write_to(self.io)
		r = TR_message.get_message(self.io)
		self.fid += 1
	
	def read_file(self, blocksize=4096, offset=0) :
		return TR_message.read_file(4096, self.next_tag, self.fid, self.io, offset)
		
	def read_dir(self, blocksize=4096) :
		stat_data = self.read_file(blocksize)
		
		stat_bytes = ByteIO.ByteIO(StringIO.StringIO(stat_data))
		stat_bytes.debug=0
		stats = []
		try :
			while 1 :
				st = TR_message.Rstat()
				st.load_from_stat_bytes(stat_bytes)
				stats.append(st)
		except :
			pass
	
		return stats