#!/usr/local/bin/python

import plan9
from wxPython.wx import *

class Form1(wxPanel):
	def __init__(self, parent, id):
		wxPanel.__init__(self, parent, id)
		
		self.p9 = plan9.one_fid_client('192.168.1.100', 'matt')
		self.p9.connect()
		self.p9.attach()
		
		self.dir = '/'
		
		self.logger = wxTextCtrl(self,5, "",wxPoint(450,20), wxSize(200,400),wxTE_MULTILINE | wxTE_READONLY)
	
		(dirs, files) = self.get_dir_listing()
		self.dir_list = wxListCtrl(self, 20, wxPoint(20, 20), wxSize(400, 400), wxLC_ICON | wxLC_SINGLE_SEL)
		self.dir_list.AssignImageList(self.get_image_list(), wxIMAGE_LIST_NORMAL)
		self.dir = ''
		self.change_directory('')
		
		EVT_LIST_ITEM_ACTIVATED(self.dir_list, 20, self.list_dbl_click)
		
	def get_image_list(self) :
		fldr = wxBitmap('/home/matt/u9fs/py/icons_folder.bmp', wxBITMAP_TYPE_BMP)
		fyle = wxBitmap('/home/matt/u9fs/py/icons_file.bmp', wxBITMAP_TYPE_BMP)
		il = wxImageList(17, 15, 1, 2)
		il.Add(fldr)
		il.Add(fyle)
		return il
		
	
	def list_dbl_click(self, event) :
		if event.GetImage() == 0 :
			self.change_directory(event.GetText())
		else :
			self.display_file(event.GetText())
			
	
	def get_dir_listing(self) :
		self.p9.open(self.dir)
		stats = self.p9.read_dir()

		
		files = []
		if self.dir != '/' :
			dirs = ['..']
		else :
			dirs = []
		for f in stats :
			if f.st_qid.type & 0x80 :
				dirs.append(f.st_name)
			else :
				files.append(f.st_name)
				
		return (dirs, files)
	
	def change_directory(self, filename) :
		if self.dir[-1:] == '/' :
			self.dir += filename
		else :
			self.dir += '/' + filename
			
		self.p9.walk()
		self.p9.walk(self.dir)
		(dirs, files) = self.get_dir_listing()
		
		self.dir_list.ClearAll()
		
		
		k = 0
		for i in xrange(0, len(dirs)) :
			self.dir_list.InsertImageStringItem(k, dirs[i], 0)
			k += 1
			
		for i in xrange(0, len(files)) :
			self.dir_list.InsertImageStringItem(k, files[i], 1)
			k += 1
		
	
	def display_file(self, filename):
		self.logger.Clear()
		self.p9.open(filename)
		self.logger.AppendText(self.p9.full_read_file())
		self.p9.walk('../' + self.dir)
		
	def select_dir(self, event) :
		self.logger.Clear()
		self.logger.AppendText('select dir %s\n' % event.GetString())

app = wxPySimpleApp()
frame = wxFrame(None, -1, " Our first Control")
Form1(frame,-1)
frame.Show(1)
app.MainLoop()